> For the complete documentation index, see [llms.txt](https://docs.seattlesolvers.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.seattlesolvers.com/photon/what-is-photon.md).

# What is Photon?

package com.seattlesolvers.solverslib.photon

Photon parallelizes hardware writes for servos and motors to make your robot's loop times faster. This is a stable version of the [now-archived PhotonCore](https://github.com/Eeshwar-Krishnan/PhotonFTC), that doesn't have probems.

{% hint style="warning" %}
Photon should be a last resort for improving loop times. Other traditional ways to help improve loop times can be found at <https://cookbook.dairy.foundation/improving_loop_times/improving_loop_times.html>.
{% endhint %}

#### How it Works

Normally with the SDK, after a setPower() or other LynxCommand, it waits for it to finish and check that it happened. But with Photon, after a setPower() or other LynxCommand, it immediately moves onto the next line of code/hardware write.

It is most effective with Swerve, because of the high amount of hardware writes frequently happening (4 servos + 4 motors).

#### Installation

See [installation page](https://docs.seattlesolvers.com/photon/pages/pfxSCrt0ymNmrj0kRXOE#build.gradle).

#### Usage

See [usage page](/photon/usage.md).


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.seattlesolvers.com/photon/what-is-photon.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
